//------------------------------------------------------------------------------
// <copyright file="XPathNodeType.cs" company="Microsoft">
//     
//      Copyright (c) 2002 Microsoft Corporation.  All rights reserved.
//     
//      The use and distribution terms for this software are contained in the file
//      named license.txt, which can be found in the root of this distribution.
//      By using this software in any fashion, you are agreeing to be bound by the
//      terms of this license.
//     
//      You must not remove this notice, or any other, from this software.
//     
// </copyright>                                                                
//------------------------------------------------------------------------------
namespace GotDotNet.XPath
{
    using System;
/*
    /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType"]/*' />
    public enum XPathNodeType {
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Root"]/*' />
        Root                    = (int)XmlNodeType.Document,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Element"]/*' />
        Element                 = (int)XmlNodeType.Element,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Attribute"]/*' />
        Attribute               = (int)XmlNodeType.Attribute,
        Namespace               = 1931,
       /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Text"]/*' />
        Text                    = (int)XmlNodeType.Text,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.SignificantWhitespace"]/*' />
        SignificantWhitespace   = (int)XmlNodeType.SignificantWhitespace,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Whitespace"]/*' />
        Whitespace              = (int)XmlNodeType.Whitespace,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.ProcessingInstruction"]/*' />
        ProcessingInstruction   = (int)XmlNodeType.ProcessingInstruction,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Comment"]/*' />
        Comment                 = (int)XmlNodeType.Comment,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.All"]/*' />
        All                     = (int)XmlNodeType.All
    }
*/
    /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType"]/*' />
    public enum XPathNodeType {
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Root"]/*' />
        Root,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Element"]/*' />
        Element,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Attribute"]/*' />
        Attribute,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Namespace"]/*' />
        Namespace,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Text"]/*' />
        Text,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.SignificantWhitespace"]/*' />
        SignificantWhitespace,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Whitespace"]/*' />
        Whitespace,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.ProcessingInstruction"]/*' />
        ProcessingInstruction,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.Comment"]/*' />
        Comment,
        /// <include file='doc\XPathNodeType.uex' path='docs/doc[@for="XPathNodeType.All"]/*' />
        All,
    }
}
